WriterBasedJsonGenerator
Date: 2016-12-03

com.fasterxml.jackson.core.json

## Class WriterBasedJsonGenerator

- java.lang.Object
- - com.fasterxml.jackson.core.JsonGenerator
  - - com.fasterxml.jackson.core.base.GeneratorBase
    - - com.fasterxml.jackson.core.json.JsonGeneratorImpl
      - - com.fasterxml.jackson.core.json.WriterBasedJsonGenerator

- All Implemented Interfaces:
    Versioned, java.io.Closeable, java.io.Flushable, java.lang.AutoCloseable

      public final class WriterBasedJsonGenerator
      extends JsonGeneratorImpl

  `JsonGenerator` that outputs JSON content using a `Writer` which handles character encoding.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.core.JsonGenerator

      `JsonGenerator.Feature`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected SerializableString` | `_currentEscape` When custom escapes are used, this member variable is used internally to hold a reference to currently used escape
    `protected char[]` | `_entityBuffer` Short (14 char) temporary buffer allocated if needed, for constructing escape sequences
    `protected char[]` | `_outputBuffer` Intermediate buffer in which contents are buffered before being written using `_writer`.
    `protected int` | `_outputEnd` End marker of the output buffer; one past the last valid position within the buffer.
    `protected int` | `_outputHead` Pointer to the first buffered character to output
    `protected int` | `_outputTail` Pointer to the position right beyond the last character to output (end marker; may point to position right beyond the end of the buffer)
    `protected char` | `_quoteChar` Character used for quoting JSON Object property names and String values.
    `protected java.io.Writer` | `_writer`
    `protected static char[]` | `HEX_CHARS`
    `protected static int` | `SHORT_WRITE`

    - ### Fields inherited from class com.fasterxml.jackson.core.json.JsonGeneratorImpl

      `_cfgUnqNames, _characterEscapes, _ioContext, _maximumNonEscapedChar, _outputEscapes, _rootValueSeparator, sOutputEscapes`

    - ### Fields inherited from class com.fasterxml.jackson.core.base.GeneratorBase

      `_cfgNumbersAsStrings, _closed, _features, _objectCodec, _writeContext, DERIVED_FEATURES_MASK, MAX_BIG_DECIMAL_SCALE, SURR1_FIRST, SURR1_LAST, SURR2_FIRST, SURR2_LAST, WRITE_BINARY, WRITE_BOOLEAN, WRITE_NULL, WRITE_NUMBER, WRITE_RAW, WRITE_STRING`

    - ### Fields inherited from class com.fasterxml.jackson.core.JsonGenerator

      `_cfgPrettyPrinter`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `WriterBasedJsonGenerator(IOContext ctxt, int features, ObjectCodec codec, java.io.Writer w)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `_flushBuffer()`
    `protected void` | `_releaseBuffers()` Method called to release any buffers generator may be holding, once generator is being closed.
    `protected void` | `_verifyValueWrite(java.lang.String typeMsg)` Method called before trying to write a value (scalar or structured), to verify that this is legal in current output state, as well as to output separators if and as necessary.
    `protected void` | `_writeBinary(Base64Variant b64variant, byte[] input, int inputPtr, int inputEnd)`
    `protected int` | `_writeBinary(Base64Variant b64variant, java.io.InputStream data, byte[] readBuffer)`
    `protected int` | `_writeBinary(Base64Variant b64variant, java.io.InputStream data, byte[] readBuffer, int bytesLeft)`
    `protected void` | `_writeFieldName(SerializableString name, boolean commaBefore)`
    `protected void` | `_writeFieldName(java.lang.String name, boolean commaBefore)`
    `protected void` | `_writePPFieldName(SerializableString name, boolean commaBefore)`
    `protected void` | `_writePPFieldName(java.lang.String name, boolean commaBefore)` Specialized version of `_writeFieldName`, off-lined to keep the "fast path" as simple (and hopefully fast) as possible.
    `boolean` | `canWriteFormattedNumbers()` Introspection method to call to check whether it is possible to write numbers using `JsonGenerator.writeNumber(java.lang.String)` using possible custom format, or not.
    `void` | `close()` Method called to close this generator, so that no more content can be written.
    `void` | `flush()` Method called to flush any buffered content to the underlying target (output stream, writer), and to flush the target itself as well.
    `int` | `getOutputBuffered()` Method for verifying amount of content that is buffered by generator but not yet flushed to the underlying target (stream, writer), in units (byte, char) that the generator implementation uses for buffering; or -1 if this information is not available.
    `java.lang.Object` | `getOutputTarget()` Method that can be used to get access to object that is used as target for generated output; this is usually either `OutputStream` or `Writer`, depending on what generator was constructed with.
    `void` | `writeBinary(Base64Variant b64variant, byte[] data, int offset, int len)` Method that will output given chunk of binary data as base64 encoded, as a complete String value (surrounded by double quotes).
    `int` | `writeBinary(Base64Variant b64variant, java.io.InputStream data, int dataLength)` Method similar to `JsonGenerator.writeBinary(Base64Variant,byte[],int,int)`, but where input is provided through a stream, allowing for incremental writes without holding the whole input in memory.
    `void` | `writeBoolean(boolean state)` Method for outputting literal JSON boolean value (one of Strings 'true' and 'false').
    `void` | `writeEndArray()` Method for writing closing marker of a JSON Array value (character ']'; plus possible white space decoration if pretty-printing is enabled).
    `void` | `writeEndObject()` Method for writing closing marker of a JSON Object value (character '}'; plus possible white space decoration if pretty-printing is enabled).
    `void` | `writeFieldName(SerializableString name)` Method similar to `JsonGenerator.writeFieldName(String)`, main difference being that it may perform better as some of processing (such as quoting of certain characters, or encoding into external encoding if supported by generator) can be done just once and reused for later calls.
    `void` | `writeFieldName(java.lang.String name)` Method for writing a field name (JSON String surrounded by double quotes: syntactically identical to a JSON String value), possibly decorated by white space if pretty-printing is enabled.
    `void` | `writeNull()` Method for outputting literal JSON null value.
    `void` | `writeNumber(java.math.BigDecimal value)` Method for outputting indicate JSON numeric value.
    `void` | `writeNumber(java.math.BigInteger value)` Method for outputting given value as JSON number.
    `void` | `writeNumber(double d)` Method for outputting indicate JSON numeric value.
    `void` | `writeNumber(float f)` Method for outputting indicate JSON numeric value.
    `void` | `writeNumber(int i)` Method for outputting given value as JSON number.
    `void` | `writeNumber(long l)` Method for outputting given value as JSON number.
    `void` | `writeNumber(short s)` Method for outputting given value as JSON number.
    `void` | `writeNumber(java.lang.String encodedValue)` Write method that can be used for custom numeric types that can not be (easily?) converted to "standard" Java number types.
    `void` | `writeRaw(char c)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
    `void` | `writeRaw(char[] text, int offset, int len)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
    `void` | `writeRaw(SerializableString text)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
    `void` | `writeRaw(java.lang.String text)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
    `void` | `writeRaw(java.lang.String text, int start, int len)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
    `void` | `writeRawUTF8String(byte[] text, int offset, int length)` Method similar to `JsonGenerator.writeString(String)` but that takes as its input a UTF-8 encoded String that is to be output as-is, without additional escaping (type of which depends on data format; backslashes for JSON).
    `void` | `writeStartArray()` Method for writing starting marker of a Array value (for JSON this is character '['; plus possible white space decoration if pretty-printing is enabled).
    `void` | `writeStartObject()` Method for writing starting marker of a JSON Object value (character '{'; plus possible white space decoration if pretty-printing is enabled).
    `void` | `writeStartObject(java.lang.Object forValue)` Method for writing starting marker of a JSON Object value (character '{'; plus possible white space decoration if pretty-printing is enabled), to represent Java given as the argument.
    `void` | `writeString(char[] text, int offset, int len)` Method for outputting a String value.
    `void` | `writeString(SerializableString sstr)` Method similar to `JsonGenerator.writeString(String)`, but that takes `SerializableString` which can make this potentially more efficient to call as generator may be able to reuse quoted and/or encoded representation.
    `void` | `writeString(java.lang.String text)` Method for outputting a String value.
    `void` | `writeUTF8String(byte[] text, int offset, int length)` Method similar to `JsonGenerator.writeString(String)` but that takes as its input a UTF-8 encoded String which has not been escaped using whatever escaping scheme data format requires (for JSON that is backslash-escaping for control characters and double-quotes; for other formats something else).

    - ### Methods inherited from class com.fasterxml.jackson.core.json.JsonGeneratorImpl

      `_checkStdFeatureChanges, _reportCantWriteValueExpectName, _verifyPrettyValueWrite, disable, enable, getCharacterEscapes, getHighestEscapedChar, setCharacterEscapes, setHighestNonEscapedChar, setRootValueSeparator, version, writeStringField`

    - ### Methods inherited from class com.fasterxml.jackson.core.base.GeneratorBase

      `_asString, _constructDefaultPrettyPrinter, _decodeSurrogate, getCodec, getCurrentValue, getFeatureMask, getOutputContext, isClosed, isEnabled, overrideStdFeatures, setCodec, setCurrentValue, setFeatureMask, useDefaultPrettyPrinter, writeObject, writeRawValue, writeRawValue, writeRawValue, writeRawValue, writeTree`

    - ### Methods inherited from class com.fasterxml.jackson.core.JsonGenerator

      `_reportError, _reportUnsupportedOperation, _throwInternal, _verifyOffsets, _writeSimpleObject, canOmitFields, canUseSchema, canWriteBinaryNatively, canWriteObjectId, canWriteTypeId, configure, copyCurrentEvent, copyCurrentStructure, getFormatFeatures, getPrettyPrinter, getSchema, overrideFormatFeatures, setPrettyPrinter, setSchema, writeArray, writeArray, writeArray, writeArrayFieldStart, writeBinary, writeBinary, writeBinary, writeBinaryField, writeBooleanField, writeEmbeddedObject, writeFieldId, writeNullField, writeNumberField, writeNumberField, writeNumberField, writeNumberField, writeNumberField, writeObjectField, writeObjectFieldStart, writeObjectId, writeObjectRef, writeOmittedField, writeStartArray, writeTypeId`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### SHORT_WRITE

          protected static final int SHORT_WRITE

      See Also:
        Constant Field Values

    - #### HEX_CHARS

          protected static final char[] HEX_CHARS

    - #### _writer

          protected final java.io.Writer _writer

    - #### _quoteChar

          protected char _quoteChar

      Character used for quoting JSON Object property names and String values.
      Since:
        2.8

    - #### _outputBuffer

          protected char[] _outputBuffer

      Intermediate buffer in which contents are buffered before being written using `_writer`.

    - #### _outputHead

          protected int _outputHead

      Pointer to the first buffered character to output

    - #### _outputTail

          protected int _outputTail

      Pointer to the position right beyond the last character to output (end marker; may point to position right beyond the end of the buffer)

    - #### _outputEnd

          protected int _outputEnd

      End marker of the output buffer; one past the last valid position within the buffer.

    - #### _entityBuffer

          protected char[] _entityBuffer

      Short (14 char) temporary buffer allocated if needed, for constructing escape sequences

    - #### _currentEscape

          protected SerializableString _currentEscape

      When custom escapes are used, this member variable is used internally to hold a reference to currently used escape

  - ### Constructor Detail

    - #### WriterBasedJsonGenerator

          public WriterBasedJsonGenerator(IOContext ctxt,
                                  int features,
                                  ObjectCodec codec,
                                  java.io.Writer w)

  - ### Method Detail

    - #### getOutputTarget

          public java.lang.Object getOutputTarget()

      Description copied from class: `JsonGenerator`
      Method that can be used to get access to object that is used as target for generated output; this is usually either `OutputStream` or `Writer`, depending on what generator was constructed with. Note that returned value may be null in some cases; including case where implementation does not want to exposed raw source to caller. In cases where output has been decorated, object returned here is the decorated version; this allows some level of interaction between users of generator and decorator object.

      In general use of this accessor should be considered as "last effort", i.e. only used if no other mechanism is applicable.

      Overrides:
        `getOutputTarget` in class `JsonGenerator`

    - #### getOutputBuffered

          public int getOutputBuffered()

      Description copied from class: `JsonGenerator`
      Method for verifying amount of content that is buffered by generator but not yet flushed to the underlying target (stream, writer), in units (byte, char) that the generator implementation uses for buffering; or -1 if this information is not available. Unit used is often the same as the unit of underlying target (that is, `byte` for `OutputStream`, `char` for `Writer`), but may differ if buffering is done before encoding. Default JSON-backed implementations do use matching units.

      Note: non-JSON implementations will be retrofitted for 2.6 and beyond; please report if you see -1 (missing override)

      Overrides:
        `getOutputBuffered` in class `JsonGenerator`
      Returns:
        Amount of content buffered in internal units, if amount known and accessible; -1 if not accessible.

    - #### canWriteFormattedNumbers

          public boolean canWriteFormattedNumbers()

      Description copied from class: `JsonGenerator`
      Introspection method to call to check whether it is possible to write numbers using `JsonGenerator.writeNumber(java.lang.String)` using possible custom format, or not. Typically textual formats allow this (and JSON specifically does), whereas binary formats do not allow this (except by writing them as Strings). Usual reason for calling this method is to check whether custom formatting of numbers may be applied by higher-level code (databinding) or not.
      Overrides:
        `canWriteFormattedNumbers` in class `JsonGenerator`

    - #### writeFieldName

          public void writeFieldName(java.lang.String name)
                              throws java.io.IOException

      Description copied from class: `JsonGenerator`
      Method for writing a field name (JSON String surrounded by double quotes: syntactically identical to a JSON String value), possibly decorated by white space if pretty-printing is enabled.

      Field names can only be written in Object context (check out JSON specification for details), when field name is expected (field names alternate with values).

      Specified by:
        `writeFieldName` in class `JsonGenerator`
      Throws:
        `java.io.IOException`

    - #### writeFieldName

          public void writeFieldName(SerializableString name)
                              throws java.io.IOException

      Description copied from class: `JsonGenerator`
      Method similar to `JsonGenerator.writeFieldName(String)`, main difference being that it may perform better as some of processing (such as quoting of certain characters, or encoding into external encoding if supported by generator) can be done just once and reused for later calls.

      Default implementation simple uses unprocessed name container in serialized String; implementations are strongly encouraged to make use of more efficient methods argument object has.

      Overrides:
        `writeFieldName` in class `GeneratorBase`
      Throws:
        `java.io.IOException`

    - #### _writeFieldName

          protected void _writeFieldName(java.lang.String name,
                             boolean commaBefore)
                                  throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### _writeFieldName

          protected void _writeFieldName(SerializableString name,
                             boolean commaBefore)
                                  throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### writeStartArray

          public void writeStartArray()
                               throws java.io.IOException

      Description copied from class: `JsonGenerator`
      Method for writing starting marker of a Array value (for JSON this is character '['; plus possible white space decoration if pretty-printing is enabled).

      Array values can be written in any context where values are allowed: meaning everywhere except for when a field name is expected.

      Specified by:
        `writeStartArray` in class `JsonGenerator`
      Throws:
        `java.io.IOException`

    - #### writeEndArray

          public void writeEndArray()
                             throws java.io.IOException

      Description copied from class: `JsonGenerator`
      Method for writing closing marker of a JSON Array value (character ']'; plus possible white space decoration if pretty-printing is enabled).

      Marker can be written if the innermost structured type is Array.

      Specified by:
        `writeEndArray` in class `JsonGenerator`
      Throws:
        `java.io.IOException`

    - #### writeStartObject

          public void writeStartObject(java.lang.Object forValue)
                                throws java.io.IOException

      Description copied from class: `JsonGenerator`
      Method for writing starting marker of a JSON Object value (character '{'; plus possible white space decoration if pretty-printing is enabled), to represent Java given as the argument. Argument is offered as metadata, but more importantly it should be assigned as the "current value" for the Object content that gets constructed and initialized.

      Object values can be written in any context where values are allowed: meaning everywhere except for when a field name is expected.

      Overrides:
        `writeStartObject` in class `GeneratorBase`
      Throws:
        `java.io.IOException`

    - #### writeStartObject

          public void writeStartObject()
                                throws java.io.IOException

      Description copied from class: `JsonGenerator`
      Method for writing starting marker of a JSON Object value (character '{'; plus possible white space decoration if pretty-printing is enabled).

      Object values can be written in any context where values are allowed: meaning everywhere except for when a field name is expected.

      Specified by:
        `writeStartObject` in class `JsonGenerator`
      Throws:
        `java.io.IOException`

    - #### writeEndObject

          public void writeEndObject()
                              throws java.io.IOException

      Description copied from class: `JsonGenerator`
      Method for writing closing marker of a JSON Object value (character '}'; plus possible white space decoration if pretty-printing is enabled).

      Marker can be written if the innermost structured type is Object, and the last written event was either a complete value, or START-OBJECT marker (see JSON specification for more details).

      Specified by:
        `writeEndObject` in class `JsonGenerator`
      Throws:
        `java.io.IOException`

    - #### _writePPFieldName

          protected void _writePPFieldName(java.lang.String name,
                               boolean commaBefore)
                                    throws java.io.IOException

      Specialized version of `_writeFieldName`, off-lined to keep the "fast path" as simple (and hopefully fast) as possible.
      Throws:
        `java.io.IOException`

    - #### _writePPFieldName

          protected void _writePPFieldName(SerializableString name,
                               boolean commaBefore)
                                    throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### writeString

          public void writeString(java.lang.String text)
                           throws java.io.IOException

      Description copied from class: `JsonGenerator`
      Method for outputting a String value. Depending on context this means either array element, (object) field value or a stand alone String; but in all cases, String will be surrounded in double quotes, and contents will be properly escaped as required by JSON specification.
      Specified by:
        `writeString` in class `JsonGenerator`
      Throws:
        `java.io.IOException`

    - #### writeString

          public void writeString(char[] text,
                         int offset,
                         int len)
                           throws java.io.IOException

      Description copied from class: `JsonGenerator`
      Method for outputting a String value. Depending on context this means either array element, (object) field value or a stand alone String; but in all cases, String will be surrounded in double quotes, and contents will be properly escaped as required by JSON specification.
      Specified by:
        `writeString` in class `JsonGenerator`
      Throws:
        `java.io.IOException`

    - #### writeString

          public void writeString(SerializableString sstr)
                           throws java.io.IOException

      Description copied from class: `JsonGenerator`
      Method similar to `JsonGenerator.writeString(String)`, but that takes `SerializableString` which can make this potentially more efficient to call as generator may be able to reuse quoted and/or encoded representation.

      Default implementation just calls `JsonGenerator.writeString(String)`; sub-classes should override it with more efficient implementation if possible.

      Overrides:
        `writeString` in class `GeneratorBase`
      Throws:
        `java.io.IOException`

    - #### writeRawUTF8String

          public void writeRawUTF8String(byte[] text,
                                int offset,
                                int length)
                                  throws java.io.IOException

      Description copied from class: `JsonGenerator`
      Method similar to `JsonGenerator.writeString(String)` but that takes as its input a UTF-8 encoded String that is to be output as-is, without additional escaping (type of which depends on data format; backslashes for JSON). However, quoting that data format requires (like double-quotes for JSON) will be added around the value if and as necessary.

      Note that some backends may choose not to support this method: for example, if underlying destination is a `Writer` using this method would require UTF-8 decoding. If so, implementation may instead choose to throw a `UnsupportedOperationException` due to ineffectiveness of having to decode input.

      Specified by:
        `writeRawUTF8String` in class `JsonGenerator`
      Throws:
        `java.io.IOException`

    - #### writeUTF8String

          public void writeUTF8String(byte[] text,
                             int offset,
                             int length)
                               throws java.io.IOException

      Description copied from class: `JsonGenerator`
      Method similar to `JsonGenerator.writeString(String)` but that takes as its input a UTF-8 encoded String which has not been escaped using whatever escaping scheme data format requires (for JSON that is backslash-escaping for control characters and double-quotes; for other formats something else). This means that textual JSON backends need to check if value needs JSON escaping, but otherwise can just be copied as is to output. Also, quoting that data format requires (like double-quotes for JSON) will be added around the value if and as necessary.

      Note that some backends may choose not to support this method: for example, if underlying destination is a `Writer` using this method would require UTF-8 decoding. In this case generator implementation may instead choose to throw a `UnsupportedOperationException` due to ineffectiveness of having to decode input.

      Specified by:
        `writeUTF8String` in class `JsonGenerator`
      Throws:
        `java.io.IOException`

    - #### writeRaw

          public void writeRaw(java.lang.String text)
                        throws java.io.IOException

      Description copied from class: `JsonGenerator`
      Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `JsonGenerator.writeRawValue(String)` instead.

      Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

      Specified by:
        `writeRaw` in class `JsonGenerator`
      Throws:
        `java.io.IOException`

    - #### writeRaw

          public void writeRaw(java.lang.String text,
                      int start,
                      int len)
                        throws java.io.IOException

      Description copied from class: `JsonGenerator`
      Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `JsonGenerator.writeRawValue(String)` instead.

      Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

      Specified by:
        `writeRaw` in class `JsonGenerator`
      Throws:
        `java.io.IOException`

    - #### writeRaw

          public void writeRaw(SerializableString text)
                        throws java.io.IOException

      Description copied from class: `JsonGenerator`
      Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `JsonGenerator.writeRawValue(String)` instead.

      Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

      The default implementation delegates to `JsonGenerator.writeRaw(String)`; other backends that support raw inclusion of text are encouraged to implement it in more efficient manner (especially if they use UTF-8 encoding).

      Overrides:
        `writeRaw` in class `JsonGenerator`
      Throws:
        `java.io.IOException`

    - #### writeRaw

          public void writeRaw(char[] text,
                      int offset,
                      int len)
                        throws java.io.IOException

      Description copied from class: `JsonGenerator`
      Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `JsonGenerator.writeRawValue(String)` instead.

      Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

      Specified by:
        `writeRaw` in class `JsonGenerator`
      Throws:
        `java.io.IOException`

    - #### writeRaw

          public void writeRaw(char c)
                        throws java.io.IOException

      Description copied from class: `JsonGenerator`
      Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `JsonGenerator.writeRawValue(String)` instead.

      Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

      Specified by:
        `writeRaw` in class `JsonGenerator`
      Throws:
        `java.io.IOException`

    - #### writeBinary

          public void writeBinary(Base64Variant b64variant,
                         byte[] data,
                         int offset,
                         int len)
                           throws java.io.IOException,
                                  JsonGenerationException

      Description copied from class: `JsonGenerator`
      Method that will output given chunk of binary data as base64 encoded, as a complete String value (surrounded by double quotes). This method defaults

      Note: because JSON Strings can not contain unescaped linefeeds, if linefeeds are included (as per last argument), they must be escaped. This adds overhead for decoding without improving readability. Alternatively if linefeeds are not included, resulting String value may violate the requirement of base64 RFC which mandates line-length of 76 characters and use of linefeeds. However, all `JsonParser` implementations are required to accept such "long line base64"; as do typical production-level base64 decoders.

      Specified by:
        `writeBinary` in class `JsonGenerator`
      Parameters:
        `b64variant` - Base64 variant to use: defines details such as whether padding is used (and if so, using which character); what is the maximum line length before adding linefeed, and also the underlying alphabet to use.
      Throws:
        `java.io.IOException`
        `JsonGenerationException`

    - #### writeBinary

          public int writeBinary(Base64Variant b64variant,
                        java.io.InputStream data,
                        int dataLength)
                          throws java.io.IOException,
                                 JsonGenerationException

      Description copied from class: `JsonGenerator`
      Method similar to `JsonGenerator.writeBinary(Base64Variant,byte[],int,int)`, but where input is provided through a stream, allowing for incremental writes without holding the whole input in memory.
      Overrides:
        `writeBinary` in class `GeneratorBase`
      Parameters:
        `b64variant` - Base64 variant to use
        `data` - InputStream to use for reading binary data to write. Will not be closed after successful write operation
        `dataLength` - (optional) number of bytes that will be available; or -1 to be indicate it is not known. If a positive length is given, `data` MUST provide at least that many bytes: if not, an exception will be thrown. Note that implementations need not support cases where length is not known in advance; this depends on underlying data format: JSON output does NOT require length, other formats may.
      Returns:
        Number of bytes read from `data` and written as binary payload
      Throws:
        `java.io.IOException`
        `JsonGenerationException`

    - #### writeNumber

          public void writeNumber(short s)
                           throws java.io.IOException

      Description copied from class: `JsonGenerator`
      Method for outputting given value as JSON number. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Overrides:
        `writeNumber` in class `JsonGenerator`
      Parameters:
        `s` - Number value to write
      Throws:
        `java.io.IOException`

    - #### writeNumber

          public void writeNumber(int i)
                           throws java.io.IOException

      Description copied from class: `JsonGenerator`
      Method for outputting given value as JSON number. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Specified by:
        `writeNumber` in class `JsonGenerator`
      Parameters:
        `i` - Number value to write
      Throws:
        `java.io.IOException`

    - #### writeNumber

          public void writeNumber(long l)
                           throws java.io.IOException

      Description copied from class: `JsonGenerator`
      Method for outputting given value as JSON number. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Specified by:
        `writeNumber` in class `JsonGenerator`
      Parameters:
        `l` - Number value to write
      Throws:
        `java.io.IOException`

    - #### writeNumber

          public void writeNumber(java.math.BigInteger value)
                           throws java.io.IOException

      Description copied from class: `JsonGenerator`
      Method for outputting given value as JSON number. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Specified by:
        `writeNumber` in class `JsonGenerator`
      Parameters:
        `value` - Number value to write
      Throws:
        `java.io.IOException`

    - #### writeNumber

          public void writeNumber(double d)
                           throws java.io.IOException

      Description copied from class: `JsonGenerator`
      Method for outputting indicate JSON numeric value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Specified by:
        `writeNumber` in class `JsonGenerator`
      Parameters:
        `d` - Number value to write
      Throws:
        `java.io.IOException`

    - #### writeNumber

          public void writeNumber(float f)
                           throws java.io.IOException

      Description copied from class: `JsonGenerator`
      Method for outputting indicate JSON numeric value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Specified by:
        `writeNumber` in class `JsonGenerator`
      Parameters:
        `f` - Number value to write
      Throws:
        `java.io.IOException`

    - #### writeNumber

          public void writeNumber(java.math.BigDecimal value)
                           throws java.io.IOException

      Description copied from class: `JsonGenerator`
      Method for outputting indicate JSON numeric value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Specified by:
        `writeNumber` in class `JsonGenerator`
      Parameters:
        `value` - Number value to write
      Throws:
        `java.io.IOException`

    - #### writeNumber

          public void writeNumber(java.lang.String encodedValue)
                           throws java.io.IOException

      Description copied from class: `JsonGenerator`
      Write method that can be used for custom numeric types that can not be (easily?) converted to "standard" Java number types. Because numbers are not surrounded by double quotes, regular `JsonGenerator.writeString(java.lang.String)` method can not be used; nor `JsonGenerator.writeRaw(java.lang.String)` because that does not properly handle value separators needed in Array or Object contexts.

      Note: because of lack of type safety, some generator implementations may not be able to implement this method. For example, if a binary JSON format is used, it may require type information for encoding; similarly for generator-wrappers around Java objects or JSON nodes. If implementation does not implement this method, it needs to throw `UnsupportedOperationException`.

      Specified by:
        `writeNumber` in class `JsonGenerator`
      Throws:
        `java.io.IOException`

    - #### writeBoolean

          public void writeBoolean(boolean state)
                            throws java.io.IOException

      Description copied from class: `JsonGenerator`
      Method for outputting literal JSON boolean value (one of Strings 'true' and 'false'). Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Specified by:
        `writeBoolean` in class `JsonGenerator`
      Throws:
        `java.io.IOException`

    - #### writeNull

          public void writeNull()
                         throws java.io.IOException

      Description copied from class: `JsonGenerator`
      Method for outputting literal JSON null value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.
      Specified by:
        `writeNull` in class `JsonGenerator`
      Throws:
        `java.io.IOException`

    - #### _verifyValueWrite

          protected void _verifyValueWrite(java.lang.String typeMsg)
                                    throws java.io.IOException

      Description copied from class: `GeneratorBase`
      Method called before trying to write a value (scalar or structured), to verify that this is legal in current output state, as well as to output separators if and as necessary.
      Specified by:
        `_verifyValueWrite` in class `GeneratorBase`
      Parameters:
        `typeMsg` - Additional message used for generating exception message if value output is NOT legal in current generator output state.
      Throws:
        `java.io.IOException`

    - #### flush

          public void flush()
                     throws java.io.IOException

      Description copied from class: `JsonGenerator`
      Method called to flush any buffered content to the underlying target (output stream, writer), and to flush the target itself as well.
      Specified by:
        `flush` in interface `java.io.Flushable`
      Specified by:
        `flush` in class `GeneratorBase`
      Throws:
        `java.io.IOException`

    - #### close

          public void close()
                     throws java.io.IOException

      Description copied from class: `JsonGenerator`
      Method called to close this generator, so that no more content can be written.

      Whether the underlying target (stream, writer) gets closed depends on whether this generator either manages the target (i.e. is the only one with access to the target -- case if caller passes a reference to the resource such as File, but not stream); or has feature `JsonGenerator.Feature.AUTO_CLOSE_TARGET` enabled. If either of above is true, the target is also closed. Otherwise (not managing, feature not enabled), target is not closed.

      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Overrides:
        `close` in class `GeneratorBase`
      Throws:
        `java.io.IOException`

    - #### _releaseBuffers

          protected void _releaseBuffers()

      Description copied from class: `GeneratorBase`
      Method called to release any buffers generator may be holding, once generator is being closed.
      Specified by:
        `_releaseBuffers` in class `GeneratorBase`

    - #### _writeBinary

          protected void _writeBinary(Base64Variant b64variant,
                          byte[] input,
                          int inputPtr,
                          int inputEnd)
                               throws java.io.IOException,
                                      JsonGenerationException

      Throws:
        `java.io.IOException`
        `JsonGenerationException`

    - #### _writeBinary

          protected int _writeBinary(Base64Variant b64variant,
                         java.io.InputStream data,
                         byte[] readBuffer,
                         int bytesLeft)
                              throws java.io.IOException,
                                     JsonGenerationException

      Throws:
        `java.io.IOException`
        `JsonGenerationException`

    - #### _writeBinary

          protected int _writeBinary(Base64Variant b64variant,
                         java.io.InputStream data,
                         byte[] readBuffer)
                              throws java.io.IOException,
                                     JsonGenerationException

      Throws:
        `java.io.IOException`
        `JsonGenerationException`

    - #### _flushBuffer

          protected void _flushBuffer()
                               throws java.io.IOException

      Throws:
        `java.io.IOException`